Produce license files using Zeng Guard.

The task can produce a license file from the given license properties or it can use a template.

author | Petr Rybak
version | $Id: 96af59b9cbecaf7f146dffab1d0b5a806a56b47f $
package | phing.tasks.ext.zendguard
since | 2.4.3
copyright | 2001,2002 THYRELL. All rights reserved

### Methods

## Returns the textual description of the task

    getDescription() : string

Inherited

inherited_from | \Task::getDescription()

### Returns

`string`The text description of the task

## Returns the location within the buildfile this task occurs.

    getLocation() : \Location

Inherited

Used by BuildException to give detailed error messages.

inherited_from | \Task::getLocation()

### Returns

`\Location`The location object describing the position of this task within the buildfile.

## Returns the owning target of this task.

    getOwningTarget() : \Target

Inherited

inherited_from | \Task::getOwningTarget()

### Returns

`\Target`The target object that owns this task

## Returns a reference to current project

    getProject() : \Project

Inherited

inherited_from | \ProjectComponent::getProject()
inherited_from | \Task::getProject()

### Returns

`\Project`Reference to current porject object

## Returns the wrapper object for runtime configuration

    getRuntimeConfigurableWrapper() : \RuntimeConfigurable

Inherited

inherited_from | \Task::getRuntimeConfigurableWrapper()

### Returns

`\RuntimeConfigurable`The wrapper object used by this task

## Returns the name of task, used only for log messages

    getTaskName() : string

Inherited

inherited_from | \Task::getTaskName()

### Returns

`string`Name of this task

## Returns the name of the task under which it was invoked, usually the XML tagname

    getTaskType() : string

Inherited

inherited_from | \Task::getTaskType()

### Returns

`string`The type of this task (XML Tag)

## Called by the parser to let the task initialize properly.

    init()

Inherited

Should throw a BuildException if something goes wrong with the build

This is abstract here, but may not be overloaded by subclasses.

inherited_from | \Task::init()

### Exceptions

`\BuildException` |

## Provides a project level log event to the task.

    log(string $msg, integer $level)

Inherited

see | \global\BuildEvent
see | \global\BuildListener
inherited_from | \Task::log()

### Parameters

#### $msg

`string`

The message to log

#### $level

`integer`

The priority of the message

## Do the work

    main()

This method may be called more than once, if the task is invoked more than once. For example, if target1 and target2 both depend on target3, then running phing target1 target2 will run all tasks in target3 twice.

Should throw a BuildException if someting goes wrong with the build

This is abstract here. Must be overloaded by real tasks.

### Exceptions

`\BuildException` |

## Configure this task if it hasn't been done already.

    maybeConfigure()

Inherited

inherited_from | \Task::maybeConfigure()

## Perfrom this task

    perform()

Inherited

inherited_from | \Task::perform()

## Sets a textual description of the task

    setDescription(string $desc)

Inherited

inherited_from | \Task::setDescription()

### Parameters

#### $desc

`string`

The text describing the task

## Process the expires property.

    setExpires(mixed $expires) : string

If the value is empty (false, '', ...) it will set the value to 'Never' Otherwise it will run the value through strtotime so relative date and time notation can be used (e.g. +1 month)

### Parameters

#### $expires

`mixed`

### Returns

`string`

## setHardwareLocked()

    setHardwareLocked($hardwareLocked)

### Parameters

#### $hardwareLocked

## setHostID()

    setHostID($hostID)

### Parameters

#### $hostID

## setIpRange()

    setIpRange($iprange)

### Parameters

#### $iprange

## setLicenseTemplate()

    setLicenseTemplate($value)

### Parameters

#### $value

## Sets the location within the buildfile this task occurs.

    setLocation(\Location $location)

Inherited

Called by the parser to set location information.

inherited_from | \Task::setLocation()

### Parameters

#### $location

`\Location`

The location object describing the position of this task within the buildfile.

## setOutputFile()

    setOutputFile($outputFile)

### Parameters

#### $outputFile

## Sets the owning target this task belongs to.

    setOwningTarget(\Target $target)

Inherited

inherited_from | \Task::setOwningTarget()

### Parameters

#### $target

`\Target`

Reference to owning target

## setPrivateKeyPath()

    setPrivateKeyPath($privateKeyPath)

### Parameters

#### $privateKeyPath

## setProductName()

    setProductName($productName)

### Parameters

#### $productName

## References the project to the current component.

    setProject(\Project $project)

Inherited

inherited_from | \ProjectComponent::setProject()
inherited_from | \Task::setProject()

### Parameters

#### $project

`\Project`

The reference to the current project

## setRegisteredTo()

    setRegisteredTo($registeredTo)

### Parameters

#### $registeredTo

## Sets the wrapper object this task should use for runtime configurable elements.

    setRuntimeConfigurableWrapper(\RuntimeConfigurable $wrapper)

Inherited

inherited_from | \Task::setRuntimeConfigurableWrapper()

### Parameters

#### $wrapper

`\RuntimeConfigurable`

The wrapper object this task should use

## Sets the name of this task for log messages

    setTaskName(string $name) : string

Inherited

inherited_from | \Task::setTaskName()

### Parameters

#### $name

`string`

### Returns

`string`A string representing the name of this task for log

## Sets the type of the task.

    setTaskType(string $name)

Inherited

Usually this is the name of the XML tag

inherited_from | \Task::setTaskType()

### Parameters

#### $name

`string`

The type of this task (XML Tag)

## setUserDefinedValues()

    setUserDefinedValues($userDefinedValues)

### Parameters

#### $userDefinedValues

## setXUserDefinedValues()

    setXUserDefinedValues($xUserDefinedValues)

### Parameters

#### $xUserDefinedValues

## setZendsignPath()

    setZendsignPath($zendsignPath)

### Parameters

#### $zendsignPath

## Creates the signed license at the defined output path

    generateLicense() : void

## It will generate a temporary license template based on the properties defined.

    generateLicenseTemplate() : string

### Returns

`string`Path of the temporary license template file

## Generates license template content based on the defined parameters

    generateLicenseTemplateContent() : string

### Returns

`string`

## Checks if the license template path is defined and returns it.

    getLicenseTemplatePath() : string

If it the license template path is not defined it will generate a temporary template file and provide it as a template.

### Returns

`string`

## Returns a name

    getRegisterSlot(string $slotName)

Inherited

inherited_from | \Task::getRegisterSlot()

### Parameters

#### $slotName

`string`

## Parse the given string in format like key1=value1;key2=value2;.

    parseAndAddUserDefinedValues(\stirng $valueString, array $valueArray, string $keyPrefix, $pairSeparator) : void

.. and converts it to array (key1=>value1, key2=value2, ...)

### Parameters

#### $valueString

`\stirng`

Semi-colon separated value pairs

#### $valueArray

`array`

Array to which the values will be added

#### $keyPrefix

`string`

Prefix to use when adding the key

#### $pairSeparator

## Prepares and returns the command that will be used to create the license.

    prepareSignCommand() : string

### Returns

`string`

## Verifies that the configuration is correct

    verifyConfiguration()

### Exceptions

`\BuildException` |

## If temporary license file was created during the process this will remove it

    cleanupTmpFiles() : void

### Properties

##

    $description : string

Inherited

inherited_from | \Task::$$description

##

    $expires : string

Used if the license is issued with a date restriction. Possible values: - 'Never', '0' or false: the license won't expire - A Date in format DD-MM-YYYY to set expiration for that date - Relative date supported by the PHP strtotime function (e.g. +1 month)

REQUIRED

##

    $hardwareLocked : bool

If set to YES, the Host-ID is required.

OPTIONAL

##

    $hostID : string

The Zend Host ID obtained from the machine where the encoded files and license are to be installed. The Zend Host ID code can be obtained by using the zendid utility. For more details, see Getting the Zend Host ID.

REQUIRED if Hardware-Locked is set equal to YES. Meaningless if Hardware-Locked is set equal to NO.

User semicolon to enter more than one Host-ID

Example: Host-ID = H:MFM43-Q9CXC-B9EDX-GWYSU;H:MFM43-Q9CXC-B9EDX-GWYTY

##

    $ipRange : string

Supports wildcards for any of the IP place holders, as well as the two types of net masks (filters). Netmask pair An IP a.b.c.d, and a netmask w.x.y.z. (That is., 10.1.0.0/255.255.0.0), where the binary of mask is applied to filter IP addresses. ip/nnn (similar to a CIDR specification) This mask consists of nnn high-order 1 bits. (That is, 10.1.0.0/16 is the same as 10.1.0.0/255.255.0.0). Instead of spelling out the bits of the subnet mask, this mask notation is simply listed as the number of 1s bits that start the mask. Rather than writing the address and subnet mask as 192.60.128.0/255.255.252.0 the network address would be written simply as: 192.60.128.0/22 which indicates starting address of the network and number of 1s bits (22) in the network portion of the address. The mask in binary is (11111111.11111111.11111100.00000000).

OPTIONAL

Example (Wildcard): IP-Range = 10.1.. Example (Net Mask): IP-Range = 10.1.0.0/255.255.0.0 Example (Net Mask): IP-Range = 10.1.0.0/16

##

    $licenseTemplate : string

If specified all license properties will be ignored and the template will be used to generate the file.

##

    $location : \Location

Inherited

inherited_from | \Task::$$location

##

    $outputFile : string

##

    $privateKeyPath : string

##

    $productName : string

This must be the same name used when encoding the PHP files.

REQUIRED

##

    $project : \Project

Inherited

inherited_from | \ProjectComponent::$$project
inherited_from | \Task::$$project

##

    $registeredTo : string

REQUIRED

##

    $target : \Target

Inherited

inherited_from | \Task::$$target

##

    $taskName : string

Inherited

inherited_from | \Task::$$taskName

##

    $taskType : string

Inherited

inherited_from | \Task::$$taskType

##

    $userDefinedValues : string

These values CANNOT be modified after the license is produced. Modification would invalidate the license.

OPTIONAL Example: Tea=Mint Flavor;Coffee=Arabica

##

    $wrapper : \RuntimeConfigurable

Inherited

inherited_from | \Task::$$wrapper

##

    $xUserDefinedValues : string

These values CAN be modified after the license is produced. Modification won't invalidate the license.

OPTIONAL Example: Tea=Mint Flavor;Coffee=Arabica

##

    $zendsignCommand

##

    $zendsignPath : string

##

    $tmpLicensePath